function result = angle(z)
  z = z + bool2s(z==0); // Pour ajouter 1 et éviter une erreur pour z=0.
  result = atan(imag(z),real(z))
endfunction;

// Supprime par continuité les sauts de 2pi dans un tableau de phases
function result = unwrap(phi)
  result = phi - [0;2*%pi*cumsum(floor(.5+diff(phi)/2/%pi))];
endfunction;


text=clipboard("paste");            // récupération du clipboard
text=strsubst(text,",",".");        // Changement séparateur décimal
ind=strindex(text,ascii(10));       // Découpage aux retours à la ligne
text=strsplit(text,ind(1:$-1));          // Découpage des lignes
text=strsubst(text,ascii(10),"");        // suppression retour à la ligne
tab=csvTextScan(text(2:$),ascii(9));     // lecture du tableau (sans la première ligne)

figure(0);clf();
plot(tab(:,1),tab(:,2));


tf=fft(tab(:,2));
dw=1/(tab($,1)-tab(1,1))
w=(0:dw:(1/(tab(2,1)-tab(1,1))))';

// fréquence de résonance :
[m,k]=max(abs(tf))
mprintf("Pulsation de résonance : %f rad/s = %f Hz\n",w(k)*2*%pi,w(k));

figure(1);clf();
//plot(w(1:100),abs(tf(1:100)));
plot2d("ln",w(2:$),20*log10(abs(tf(2:$))));
//plot2d("ln",w(2:200),20*log10(abs(tf2(2:200))));

figure(2);clf();
//plot(atan(imag(tf),real(tf)),"g");
plot2d("ln",w(2:$),unwrap(angle(tf(2:$)))*180/%pi)
