
if size(reponse_choix)<3 then
    reponse_choix=[2 1 1 1];
end

listechoix1=list('Systèmes simulé : ',reponse_choix(1),['Chateau d''eau','Banc']);
listechoix2=list('Présence d''amortisseurs aux pieds : ',reponse_choix(2),['NON','OUI']);
//listechoix3=list('Type d''excitation : ',reponse_choix(3),['Sinus','Séisme']);
listechoix3=list('Animation de la réponse : ',reponse_choix(3),['NON','OUI']);
reponse_choix=x_choices('Configuration de la simulation',list(listechoix1,listechoix2,listechoix3));

if isempty(reponse_choix) then
    return;
end

//Paramètres de la géométrie et des poutres
//cas=input("Géométrie réelle (1) ou banc DMS (0) ? ")
if (reponse_choix(1)==1) then
    exec(chemin_dossier_tp+'simulations\parametres_chateau_eau.sce',-1)
else
    exec(chemin_dossier_tp+'simulations\parametres_banc.sce',-1)
end

// Structure
//   ###################
//   ################### Masse M chateau d'eau
//   ###################
//   ###################
//   -------------------
//   | B      L b2     | C
//   |                 |
//   |                 |
//   |                 |
//   |                 |         ^ Y
//   |b1            b3 | H       |
//   |                 |         |
//   |                 |         |
//   |                 |         |
//   |                 |         ---------> X
//   |                 |
//   |                 |
//   | A               | D
// ------------------------- Sol en mouvement avec accélération gamma

// Discrétisation
nh=6;
//nl=5;


// --- Lecture fichier d'accélération séisme ----
time=0:0.1:10;
acceleration=0*time;
acceleration(3:13)=acceleration(3:13)+1;

// ------------

//Tables de noeuds :
// Numérotation des noeuds en suivant la poutre de A à D
nodes=[];
ptA=[0 0];ptB=[0 H]; ptC=[L H];ptD=[L 0];
node_AB=ones(nh,1)*ptA+(0:1/(nh-1):1)'*(ptB-ptA);
//node_BC=ones(nl-1,1)*ptB+(1/(nl-1):1/(nl-1):1)'*(ptC-ptB);
node_DC=ones(nh,1)*ptD+(0:1/(nh-1):1)'*(ptC-ptD);
nodes=[node_AB;node_DC];

//Tables conectivité
// Numérotation des éléments en suivant la poutre
connectivity=[];
connectivity=[(1:nh-1)'   (2:nh)'];             // connectivité de la première poutre AB, les éléments se suivent...
connectivity=[connectivity ; connectivity+nh];  // ajout de la deuxième poutre par copie de la première en décalant les No noeuds de nh

//Définition des CL en déplacement :
nCLu = [1 nh+1 nh 2*nh];    //numéro des noeuds avec CL en déplacement : points A et D (encastrement) et points B et C (angle nul)
CLu=[];
//cas=input("Chateau d''eau sur amortisseur ? (0/1)")
if (reponse_choix(2)==2) then
    disp("Présence d''amortisseurs")
    CLu(1,:)=[0 %nan];     //vecteur déplacement (v,theta) pour le noeud : deplacement normal et angle
    CLu(2,:)=[0 %nan];  //on met %nan quand le mouvement est libre
else
    disp("Pas d''amortisseurs")
    CLu(1,:)=[0 0];     //vecteur déplacement (v,theta) pour le noeud : deplacement normal et angle
    CLu(2,:)=[0 0];  //on met %nan quand le mouvement est libre
end
CLu(3,:)=[%nan 0];  //on met %nan quand le mouvement est libre
CLu(4,:)=[%nan 0];  //on met %nan quand le mouvement est libre

nCLf = [nh];
CLf=[Fexterieure %nan];
//CLf(1,:)=[%nan -500];  //on met %nan quand l'effort n'est pas imposé

nbnodes=size(nodes,1);       //nombre de noeuds
nbelem=size(connectivity,1); //nombre d'éléments

//déclaration de la matrice de rigidité :
K=zeros(2*nbnodes,2*nbnodes); //2 inconnues par noeuds
M=zeros(2*nbnodes,2*nbnodes); //2 inconnues par noeuds

//Assemblage de la matrice :1
for (i=[1:nbelem])
    num1 = connectivity(i,1);                                                 //numéro de l'élément 1 de la barre
    num2 = connectivity(i,2);                                                 //numéro de l'élément 2 de la barre
    l=sqrt((nodes(num1,1)-nodes(num2,1))^2+(nodes(num1,2)-nodes(num2,2))^2);  // longueur de la barre
    A=[12 6*l ; 6*l 4*l^2];    // Blocs de la matrice de rigidité pour un élément poutre en flexion
    B=[-12 6*l ; -6*l 2*l^2];
    C=[12 -6*l ; -6*l 4*l^2];
    Kelem=E*I/l^3*[A,B;B',C];  // Matrice de rigidité d'un élément pour un élément poutre en flexion
    repddl = [num1*2-1 num1*2 num2*2-1 num2*2];                               // détermination des numéros de case de la matrice globale à remplir
    K(repddl,repddl)=K(repddl,repddl)+Kelem;                    // ajout de la matrice élémentaire dans la matrice globale
    
    
    A=[156 22*l ; 22*l 4*l^2];
    B=[54 -13*l ; 13*l -3*l^2];
    C=[156 -22*l ; -22*l 4*l^2];
    Melem=rho*S*l/420*[A,B;B',C];  // Matrice de masse d'un élément pour un élément poutre en flexion
    repddl = [num1*2-1 num1*2 num2*2-1 num2*2];                               // détermination des numéros de case de la matrice globale à remplir
    M(repddl,repddl)=M(repddl,repddl)+Melem;                    // ajout de la matrice élémentaire dans la matrice globale
end

//disp(K) // on peut montrer que la matrice est singulière avec inv(K)

// liaison des deux noeuds en B et C à la masse supérieure : les deux noeuds sont soudés.
// Pour cela, les lignes et col des ddl du noeud C sont additionnées à celle du noeud B puis supprimées
numB=nh;    // numero noeud en B
numC=2*nh;  // numero noeud en C
repddlB = [numB*2-1 numB*2];        // détermination des numéros de case des ddl de C
repddlC = [numC*2-1 numC*2];        // détermination des numéros de case des ddl de C
K(repddlB,repddlB)=K(repddlB,repddlB)+K(repddlC,repddlC);   // superposition des lignes en B
K(repddlB,repddlC-2)=K(repddlB,repddlC-2)+K(repddlC,repddlC-2);   // superposition des lignes en B
K(repddlC-2,repddlB)=K(repddlC-2,repddlB)+K(repddlC-2,repddlC);   // superposition des lignes en B
K=K(1:4*nh-2,1:4*nh-2);
M(repddlB,repddlB)=M(repddlB,repddlB)+M(repddlC,repddlC);   // superposition des lignes en B
M(repddlB,repddlC-2)=M(repddlB,repddlC-2)+M(repddlC,repddlC-2);   // superposition des lignes en B
M(repddlC-2,repddlB)=M(repddlC-2,repddlB)+M(repddlC-2,repddlC);   // superposition des lignes en B
M=M(1:4*nh-2,1:4*nh-2);
// Matrice d'amortissement et modif de la raideur aux pieds
C=0*M;
if (reponse_choix(2)==2) then
C(2,2)=amortissement_pied;
C(2*(nh+1),2*(nh+1))=amortissement_pied;
K(2,2)=K(2,2)*raideur_pied;
K(2*(nh+1),2*(nh+1))=K(2*(nh+1),2*(nh+1))*raideur_pied;

end

// Prise en compte des CL en déplacement:
u=zeros(nbnodes*2,1);
cl = ones(nbnodes*2,1)
for i=[1:length(nCLu)]
    if ~isnan(CLu(i,1)) then
        cl(2*nCLu(i)-1)=0;
        u(2*nCLu(i)-1) = CLu(i,1);
    end
    if ~isnan(CLu(i,2)) then
        cl(2*nCLu(i))=0;
        u(2*nCLu(i)) = CLu(i,2);
    end
end

// Prise en compte des CL en effort:
f=zeros(nbnodes*2,1);
for i=[1:length(nCLf)]
    if ~isnan(CLf(i,1)) then
        f(2*nCLf(i)-1) = CLf(i,1);
    end
    if ~isnan(CLf(i,2)) then
        f(2*nCLf(i)) = CLf(i,2);
    end
end

// Ajout de la masse du chateau d'eau en B
M(2*nh-1,2*nh-1)=M(2*nh-1,2*nh-1)+Mchateau

// suppression des lignes du noeud C (confondu avec B)
u=u(1:4*nh-2);
cl=cl(1:4*nh-2);
f=f(1:4*nh-2);

//return
// ----Résolution temporelle
//dt=0.01;
//T=60;
temps=(0:dt:T)';

// Résolution du problème en déplacement dynamique
ddlbloq = find(cl) // trouve les noeuds libre (=1)
//f=f-K*u;           // prise en compte des déplacements imposés

//Calcul de la condition initiale par un calcul de statique
u(ddlbloq)= K(ddlbloq,ddlbloq)\f(ddlbloq);


// On supprime les conditions limites en effort
f=zeros(nbnodes*2,1);

// Schéma temporel de Newmarck
b1=0.5;
b2=0.5;
u_temp=zeros(size(u,1),size(temps,1));
u_temp(:,1)=u;
v=u*0;
g=u*0;

for i=2:size(temps,1)
    //disp(i)
    // calcul des estimateurs chapeaux
    u(ddlbloq)=u(ddlbloq)+dt*v(ddlbloq)+(1-b2)*dt^2/2*g(ddlbloq);
    v(ddlbloq)=v(ddlbloq)+(1-b1)*dt*g(ddlbloq);
    // Resolution
    g(ddlbloq)=-(M(ddlbloq,ddlbloq)+b1*dt*C(ddlbloq,ddlbloq)+0.5*b2*dt^2*K(ddlbloq,ddlbloq))\(C(ddlbloq,ddlbloq)*v(ddlbloq)+K(ddlbloq,ddlbloq)*u(ddlbloq)+f(ddlbloq));
    // Calcul du pas de temps suivant
    u=u+b2*dt^2/2*g;
    v=v+b1*dt*g;
    // enregistrement déplacement
    u_temp(:,i)=u;
end




//return

//--- Affichage -----
//return
//cas=input("Animation réponse ? (0/1)")
if (reponse_choix(3)==2) then
h=figure();

for j=1:5:(size(temps,1)/3)
    disp(j);
u=u_temp(:,j);
//On rétablit le point C
u=[u;u(2*nh-1);u(2*nh)];

//Affichage des résultats

drawlater
clf;
amplif = 1;
for i=[1:nbelem]
    num1 = connectivity(i,1);                                                 //numéro de l'élément 1 de la barre
    num2 = connectivity(i,2);                                                 //numéro de l'élément 2 de la barre
    plot([nodes(num1,1),nodes(num2,1)],[nodes(num1,2),nodes(num2,2)],'k-+');
    plot([nodes(num1,1)+u(num1*2-1)*amplif,nodes(num2,1)+u(num2*2-1)*amplif],[nodes(num1,2),nodes(num2,2)],'r-+','thickness',3)
end

//xstring(nodes(4,1),nodes(4,2),string(u(4*2)*1e3))
// tracé de la plaque supérieure
    plot([nodes(nh,1),nodes(2*nh,1)],[nodes(nh,2),nodes(2*nh,2)],'k-+');
    plot([nodes(nh,1)+u(nh*2-1)*amplif,nodes(2*nh,1)+u(2*nh*2-1)*amplif],[nodes(nh,2),nodes(2*nh,2)],'r-+','thickness',3)


h.children(1).data_bounds=[min(nodes(:,1))-2e-1 min(nodes(:,2))-5e-2 ; max(nodes(:,1))+2e-1 max(nodes(:,2))+5e-2];
h.children(1).isoview="on";
drawnow
xs2gif(gcf(),msprintf("img%02d.gif",j));
end

end // fin if (0)

//return
h2=figure(2)
clf;
plot(temps,u_temp(2*nh-1,:))
